var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/LiveInfiniteQueryObserver.ts
import { InfiniteQueryObserver } from "@tanstack/query-core";

// src/utils/ensureArray.ts
var ensureArray = /* @__PURE__ */ __name((maybeArray) => Array.isArray(maybeArray) ? maybeArray : [
  maybeArray
], "ensureArray");

// src/utils/normalizeRecordQueryResult.ts
var normalizeRecordQueryResult = /* @__PURE__ */ __name((result) => ensureArray(result).flat().filter((record) => record != null), "normalizeRecordQueryResult");

// src/LiveInfiniteQueryObserver.ts
var _LiveInfiniteQueryObserver = class _LiveInfiniteQueryObserver extends InfiniteQueryObserver {
  constructor(client, options) {
    super(client, __spreadProps(__spreadValues({
      // eslint-disable-next-line @typescript-eslint/promise-function-async
      queryFn: (ctx) => {
        var _a;
        const getQueryOrExpressions = (_a = ctx.meta) == null ? void 0 : _a.getQueryOrExpressions;
        if (getQueryOrExpressions == null) {
          return Promise.reject("Missing meta.getQueryOrExpressions");
        }
        const memorySource = client.getMemorySource();
        return memorySource.activated.then(() => __async(this, null, function* () {
          var _a2;
          const result = yield memorySource.query(getQueryOrExpressions(memorySource.queryBuilder, ctx.queryKey, (_a2 = ctx.pageParam) != null ? _a2 : 0));
          const normalizedResult = normalizeRecordQueryResult(result);
          if (normalizedResult.length > 0) {
            return result;
          }
          if (Array.isArray(result)) {
            return [];
          }
          return void 0;
        }));
      },
      initialData: () => {
        var _a, _b;
        const enabled = options.enabled;
        if (enabled === false) {
          return;
        }
        const queryKey = options.queryKey;
        if (queryKey == null) {
          return;
        }
        const getQueryOrExpressions = (_a = options.meta) == null ? void 0 : _a.getQueryOrExpressions;
        if (getQueryOrExpressions == null) {
          return;
        }
        const pageSize = (_b = options.meta) == null ? void 0 : _b.pageSize;
        if (pageSize == null) {
          return;
        }
        const memorySource = client.getMemorySourceIfActivated();
        if (memorySource == null) {
          return;
        }
        const records = memorySource.cache.query(getQueryOrExpressions(memorySource.queryBuilder, queryKey, 0));
        if (records.length > 0) {
          return {
            pages: [
              records.slice(0, pageSize)
            ],
            pageParams: [
              0
            ]
          };
        }
        return void 0;
      },
      staleTime: Infinity,
      cacheTime: 0
    }, options), {
      meta: __spreadValues({
        isInfinite: true
      }, options.meta)
    }));
  }
  setOptions(options, notifyOptions) {
    let optionsWithMetaIsInfinite;
    if ((options == null ? void 0 : options.meta) != null && "isInfinite" in options.meta) {
      optionsWithMetaIsInfinite = options;
    } else {
      optionsWithMetaIsInfinite = __spreadProps(__spreadValues({}, options), {
        meta: __spreadValues({
          isInfinite: true
        }, options == null ? void 0 : options.meta)
      });
    }
    super.setOptions(optionsWithMetaIsInfinite, notifyOptions);
  }
};
__name(_LiveInfiniteQueryObserver, "LiveInfiniteQueryObserver");
var LiveInfiniteQueryObserver = _LiveInfiniteQueryObserver;

// src/LiveQueryClient.ts
import { QueryClient } from "@tanstack/query-core";

// src/LiveQueryAdapter.ts
var _LiveQueryAdapter = class _LiveQueryAdapter {
  constructor(config) {
    __publicField(this, "client");
    __publicField(this, "query");
    __publicField(this, "unsubscribeFromLiveQuery");
    __publicField(this, "disconnected", false);
    this.client = config.client;
    this.query = config.query;
    void this.connect();
  }
  connect() {
    return __async(this, null, function* () {
      var _a;
      const memorySource = this.client.getMemorySource();
      yield memorySource.activated;
      if (this.disconnected) {
        return;
      }
      const getQueryOrExpressions = (_a = this.query.options.meta) == null ? void 0 : _a.getQueryOrExpressions;
      if (getQueryOrExpressions == null) {
        throw new Error("Missing meta.getQueryOrExpressions");
      }
      const liveQuery = memorySource.cache.liveQuery(getQueryOrExpressions(memorySource.queryBuilder, this.query.queryKey));
      this.unsubscribeFromLiveQuery = liveQuery.subscribe((update) => {
        void this.onLiveQueryUpdate(update);
      });
    });
  }
  disconnect() {
    var _a;
    (_a = this.unsubscribeFromLiveQuery) == null ? void 0 : _a.call(this);
    this.disconnected = true;
  }
  onLiveQueryUpdate(update) {
    return __async(this, null, function* () {
      var _a, _b, _c, _d, _e;
      if (((_a = this.query.options.meta) == null ? void 0 : _a.isInfinite) === true) {
        const pageSize = this.query.options.meta.pageSize;
        if (pageSize == null) {
          throw new Error("Missing meta.pageSize");
        }
        const wasFetching = this.client.isFetching(this.query.queryKey) > 0;
        const wasFetchingNextPage = wasFetching && ((_c = (_b = this.query.state.fetchMeta) == null ? void 0 : _b.fetchMore) == null ? void 0 : _c.direction) === "forward";
        const wasFetchingPreviousPage = wasFetching && ((_e = (_d = this.query.state.fetchMeta) == null ? void 0 : _d.fetchMore) == null ? void 0 : _e.direction) === "backward";
        if (wasFetching) {
          yield this.client.cancelQueries(this.query.queryKey);
        }
        if (this.disconnected) {
          return;
        }
        this.client.setQueryData(this.query.queryKey, (data) => {
          var _a2;
          const records = update.query();
          const pages = [];
          const pageParams = [];
          let offset = 0;
          let page = -1;
          while (((_a2 = data == null ? void 0 : data.pages.length) != null ? _a2 : 1) > pages.length && offset < records.length) {
            pages.push(records.slice(offset, offset += pageSize));
            pageParams.push(++page);
          }
          return {
            pages,
            pageParams
          };
        });
        if (wasFetching && !(wasFetchingNextPage || wasFetchingPreviousPage)) {
          void this.client.refetchQueries(this.query.queryKey);
        }
      } else {
        const wasFetching = this.client.isFetching(this.query.queryKey) > 0;
        if (wasFetching) {
          yield this.client.cancelQueries(this.query.queryKey);
        }
        if (this.disconnected) {
          return;
        }
        this.client.setQueryData(this.query.queryKey, update.query());
        if (wasFetching) {
          void this.client.refetchQueries(this.query.queryKey);
        }
      }
    });
  }
};
__name(_LiveQueryAdapter, "LiveQueryAdapter");
var LiveQueryAdapter = _LiveQueryAdapter;

// src/LiveQueryAdapterCache.ts
var _LiveQueryAdapterCache = class _LiveQueryAdapterCache {
  constructor(config) {
    __publicField(this, "adapterMap", {});
    __publicField(this, "client");
    const client = this.client = config.client;
    client.getQueryCache().subscribe((event) => this.onQueryCacheNotifyEvent(event));
  }
  onQueryCacheNotifyEvent({ type, query }) {
    let adapter = this.adapterMap[query.queryHash];
    const queryIsDisabled = query.isDisabled();
    if (adapter != null) {
      if (type === "removed" || queryIsDisabled) {
        adapter.disconnect();
        adapter = this.adapterMap[query.queryHash] = void 0;
      }
    } else {
      if (type !== "removed" && !queryIsDisabled) {
        adapter = this.adapterMap[query.queryHash] = new LiveQueryAdapter({
          client: this.client,
          query
        });
      }
    }
  }
};
__name(_LiveQueryAdapterCache, "LiveQueryAdapterCache");
var LiveQueryAdapterCache = _LiveQueryAdapterCache;

// src/LiveQueryClient.ts
var _LiveQueryClient = class _LiveQueryClient extends QueryClient {
  constructor(config) {
    super(config);
    __publicField(this, "memorySource");
    __publicField(this, "liveQueryAdapterCache");
    __publicField(this, "memorySourceIsActivated", false);
    const memorySource = this.memorySource = config.memorySource;
    this.liveQueryAdapterCache = new LiveQueryAdapterCache({
      client: this
    });
    void memorySource.activated.then(() => {
      this.memorySourceIsActivated = true;
    });
  }
  getMemorySource() {
    return this.memorySource;
  }
  getMemorySourceIfActivated() {
    if (this.memorySourceIsActivated) {
      return this.memorySource;
    }
    return void 0;
  }
};
__name(_LiveQueryClient, "LiveQueryClient");
var LiveQueryClient = _LiveQueryClient;

// src/LiveQueryObserver.ts
import { QueryObserver } from "@tanstack/query-core";
var _LiveQueryObserver = class _LiveQueryObserver extends QueryObserver {
  constructor(client, options) {
    super(client, __spreadValues({
      // eslint-disable-next-line @typescript-eslint/promise-function-async
      queryFn: (ctx) => {
        var _a;
        const getQueryOrExpressions = (_a = ctx.meta) == null ? void 0 : _a.getQueryOrExpressions;
        if (getQueryOrExpressions == null) {
          return Promise.reject("Missing meta.getQueryOrExpressions");
        }
        const memorySource = client.getMemorySource();
        return memorySource.activated.then(() => __async(this, null, function* () {
          var _a2;
          const result = yield memorySource.query(getQueryOrExpressions(memorySource.queryBuilder, ctx.queryKey, (_a2 = ctx.pageParam) != null ? _a2 : 0));
          const normalizedResult = normalizeRecordQueryResult(result);
          if (normalizedResult.length > 0) {
            return result;
          }
          if (Array.isArray(result)) {
            return [];
          }
          return void 0;
        }));
      },
      initialData: () => {
        var _a;
        const enabled = options.enabled;
        if (enabled === false) {
          return;
        }
        const queryKey = options.queryKey;
        if (queryKey == null) {
          return;
        }
        const getQueryOrExpressions = (_a = options.meta) == null ? void 0 : _a.getQueryOrExpressions;
        if (getQueryOrExpressions == null) {
          return;
        }
        const memorySource = client.getMemorySourceIfActivated();
        if (memorySource == null) {
          return;
        }
        const result = memorySource.cache.query(getQueryOrExpressions(memorySource.queryBuilder, queryKey));
        const normalizedResult = normalizeRecordQueryResult(result);
        if (normalizedResult.length > 0) {
          return result;
        }
        if (Array.isArray(result)) {
          return [];
        }
        return void 0;
      },
      staleTime: Infinity,
      cacheTime: 0
    }, options));
  }
};
__name(_LiveQueryObserver, "LiveQueryObserver");
var LiveQueryObserver = _LiveQueryObserver;
export {
  LiveInfiniteQueryObserver,
  LiveQueryClient,
  LiveQueryObserver
};
